#ifndef __ST7789_H__
#define __ST7789_H__

#include <cstdint>
#include "gpio_interface.h"
#include "spi_interface.h"

class St7789
{
public:
    St7789(interfaces::SpiInterface &,
           interfaces::GpioInterface &,
           interfaces::GpioInterface &,
           interfaces::GpioInterface &,
           interfaces::GpioInterface &);

private:
    interfaces::SpiInterface & spi;
    interfaces::GpioInterface & reset;
    interfaces::GpioInterface & data_command;
    interfaces::GpioInterface & backlight;
    interfaces::GpioInterface & select;

    void init();
    void send_cmd(uint8_t);
    void send_data(uint8_t);
    void clear(uint16_t Color);
    void set_windows(uint16_t x_start, uint16_t y_start, uint16_t x_end, uint16_t y_end);
};

#endif
